/*
PolyGun

Copyright (c) 2023 mrkubax10 <mrkubax10@onet.pl>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef POLYGUN_AUDIO_SOURCE_HPP
#define POLYGUN_AUDIO_SOURCE_HPP

#include <memory>
#include <glm/glm.hpp>

namespace polygun::audio {
	class AudioBuffer;
	class AudioSource final {
	public:
		AudioSource();
		AudioSource(const std::shared_ptr<AudioBuffer>& buffer);
		~AudioSource();

		void set_buffer(const std::shared_ptr<AudioBuffer>& buffer);
		AudioBuffer& get_buffer() { return *m_buffer; }
		void set_gain(float gain);
		void set_position(const glm::vec3& pos);
		void set_velocity(const glm::vec3& vel);

		void play(bool looping = false);
		void stop();
		void pause();
		bool is_playing() const;

	private:
		std::shared_ptr<AudioBuffer> m_buffer;
		unsigned m_source_id;
		bool m_valid;
	};
}

#endif // POLYGUN_AUDIO_SOURCE_HPP
